<?php
////////////////ERFD10///////////////////////
// Nos fonctions pour la gestion des groupes
/////////////////////////////////////////////

// Ce fichier ne sera execute qu'une fois
if (defined("_INC_GROUPE")) return;
define("_INC_GROUPE", "1");



function nom_groupe($id_grp){

  $res = spip_query("SELECT * FROM spip_groupes WHERE id_groupe='$id_grp'");
  $row = spip_fetch_array($res);

  return $row['nom_groupe'];

}



///////////////////////////////////////////////////////////////////////////////
// Retrouver la liste des groupes auxquels appartient l'utilisateur en ligne...
//
// RENVOIE : les groupes autoriss pour l'utilisateur, qui ne sont PAS  la 
// poubelle, et qui contiennent des rubriques
///////////////////////////////////////////////////////////////////////////////

function groupe_auteur_session() {

  $local_id_auteur = $GLOBALS['auteur_session']['id_auteur'];
  $result = spip_query("SELECT * FROM spip_groupes_auteurs WHERE id_auteur='$local_id_auteur'");
		
  $groupes_dispo= array();
		
  while($row = spip_fetch_array($result)) {
    $grp = $row['id_groupe'];
    $res_verif_grp = spip_query("SELECT spip_groupes.* FROM spip_groupes, spip_groupes_rubriques WHERE spip_groupes.id_groupe='$grp' AND spip_groupes.id_groupe=spip_groupes_rubriques.id_groupe");
    $row_verif_grp = spip_fetch_array($res_verif_grp);
			
    //echo $row_verif_grp['statut'];
    if ($row_verif_grp['statut']=="0") {
      $groupes_dispo[]=$grp;
    }
    
  }
		
  if (sizeof($groupes_dispo)>0) {
    $sql_in = join($groupes_dispo,",");
    $result =spip_query("SELECT * FROM spip_groupes WHERE id_groupe IN ($sql_in) ORDER BY nom_groupe");
    $groupes_dispo = array();
    while($row = spip_fetch_array($result) )
      {
	$groupes_dispo[]=$row['id_groupe'];
      }
  }

  $GLOBALS['groupes_dispo'] = $groupes_dispo;

}





///////////////////////////////////////////////////////////////////
// vrifier si la rubrique appartient aux groupes accessibles
//  (ou est enfant d'une rubrique appartenant au groupe)
///////////////////////////////////////////////////////////////////
//retourne : -1 (faux) ou n de rubrique (vrai)

function rubrique_autorisee($coll) {
  // Secu :  

  //Tester pour chaque rubrique parente en remontant jusqu la rubrique 0 : 
  global $groupes_dispo, $connect_id_auteur;

  $ok=FALSE;
  $rub=$coll;
  while($ok==FALSE and $rub>0){

    $query_rub_grp = "SELECT * FROM spip_groupes_rubriques WHERE id_rubrique=\"$rub\"";
    $result_rub_grp = spip_query($query_rub_grp);
    $row_rub_grp = spip_fetch_array($result_rub_grp);
    $grp=$row_rub_grp['id_groupe'];
	
    if ($grp!="" and (in_array($grp,$groupes_dispo ) or $connect_id_auteur==1 ) ) {
      $ok=TRUE;
    }	
    else // recup id parent : on teste la rubrique parente
      {
	$query_rub_parent = "SELECT id_parent FROM spip_rubriques WHERE id_rubrique=\"$rub\"";
	$result_rub_parent = spip_query($query_rub_parent);
	$row_rub_parent = spip_fetch_array($result_rub_parent);
	$rub = $row_rub_parent['id_parent'];
	if($rub=="") $rub=-1; /// $coll n'existait pas...
      }
  } // while

  if ($ok or $rub==0) return $rub;   
  else return -1;

}




//////////////////////////////////////////////////////////////////////////////////
// afficher la liste des groupes dispos + affiche un groupe si $id_grp est prcis
//////////////////////////////////////////////////////////////////////////////////

function rubrique_grp($id_grp){

  global $les_rubriques_grp,$groupes_dispo,$couleur_foncee,$connect_id_auteur;

  //secu
  // si aucun groupe prcis OU s'il grp non autoris
  if ( ($id_grp=="" or !in_array($id_grp,$groupes_dispo) ) and $connect_id_auteur!=1 ) 
    return;
	
  //les rubriques du groupe :
  $query_rub_grp = "SELECT * FROM spip_groupes_rubriques WHERE id_groupe=\"$id_grp\"";
  $result_rub_grp = spip_query($query_rub_grp);

  while($row_rub_grp = spip_fetch_array($result_rub_grp)) {
    $id_rubrique = $row_rub_grp['id_rubrique'];
    $query2 = "SELECT * FROM spip_rubriques WHERE id_rubrique=\"$id_rubrique\" ORDER BY titre";
    $result2 = spip_query($query2);
    $row=spip_fetch_array($result2);

    $id_parent=$row['id_parent'];
    $titre=$row['titre'];
		
    $descriptif=propre($row['descriptif']);
    
    $bouton_layer = bouton_block_invisible("enfants$id_rubrique");
    $les_sous_enfants = sous_enfant($id_rubrique);
    
    $les_rubriques_grp.= "<P>";
    if ($id_parent == "0") $les_rubriques_grp .= debut_cadre_relief("secteur-24.gif", true);
    else  $les_rubriques_grp .= debut_cadre_relief("rubrique-24.gif", true);
    $les_rubriques_grp.= "<FONT FACE=\"Verdana,Arial,Helvetica,sans-serif\">";

    if (strlen($les_sous_enfants) > 0){
      $les_rubriques_grp.= $bouton_layer;
    }

    if  (acces_restreint_rubrique($id_rubrique))
      $les_rubriques_grp.= "<img src='img_pack/admin-12.gif' alt='' width='12' height='12' title='Vous pouvez administrer cette rubrique et ses sous-rubriques'> ";
    $les_rubriques_grp.= "<B><A HREF='naviguer.php3?coll=$id_rubrique'><font color='$couleur_foncee'>".typo($titre)."</font></A></B>";
    if (strlen($descriptif)>1)
      $les_rubriques_grp.="<BR><FONT SIZE=1>$descriptif</FONT>";

    $les_rubriques_grp.= "</FONT>";

    $les_rubriques_grp.="<FONT FACE='arial, helvetica'>";
    $les_rubriques_grp .= $les_sous_enfants;
    $les_rubriques_grp .="</FONT>&nbsp;";
    $les_rubriques_grp .= fin_cadre_relief(true);
  }

}





///////////////////////////////////////////////////////////////////
// Rcupre sous forme d'un tableau les rubriques du groupe $groupe
///////////////////////////////////////////////////////////////////

function rubriques($leparent, $groupe) {

  global $i;
  global $couleur_claire;
  static $rub;

  if ($leparent == 0) $rub = array();

  $i++;
  if($leparent == 0) {
    $query ="SELECT DISTINCT id_rubrique FROM spip_groupes_rubriques WHERE id_groupe='$groupe'";
    $result = spip_query($query);
    while ($row = spip_fetch_array($result))
      $rubrik .= $row['id_rubrique'].",";
    $rubrik = "(".$rubrik."0)";
    $query="SELECT DISTINCT * FROM spip_rubriques WHERE id_parent='$leparent' AND id_rubrique IN $rubrik ORDER BY titre";
  }
  else
    $query="SELECT DISTINCT * FROM spip_rubriques WHERE id_parent='$leparent' ORDER BY titre";

  $result=spip_query($query);

  while($row=spip_fetch_array($result)){
    $my_rubrique=$row['id_rubrique'];
    
    $rub[] = $my_rubrique;
		
    rubriques($my_rubrique, $groupe);
    
  }
  $i=$i-1;
  return $rub;
}




/////////////////////////////////////////////////////////
function chaine_rubrique_groupe ($groupe=1){
  $r = rubriques(0,$groupe);
  if (count($r) != 0) 
    $chaine = "(".(implode (",", $r)).")";
  else 
    $chaine = "(0)";
  
  return $chaine;
}




///////////////////////////////////////////////////////////////////////////
// Rcupre sous forme d'une chaine les forums autoriss du groupe $groupe
///////////////////////////////////////////////////////////////////////////

function recup_forum($groupe=1){
  $query_article = "SELECT DISTINCT id_forum FROM spip_forum, spip_groupes_articles WHERE spip_groupes_articles.id_groupe='$groupe' AND spip_groupes_articles.id_article=spip_forum.id_article";
  $result_article = spip_query($query_article);
	
  while ($row = spip_fetch_array($result_article)) {
    $chaine .= $row['id_forum'].",";
  }
	
  $query_breve = "SELECT DISTINCT id_forum FROM spip_forum, spip_groupes_breves WHERE spip_groupes_breves.id_groupe='$groupe' AND spip_groupes_breves.id_breve=spip_forum.id_breve";
  $result_breve = spip_query($query_breve);
	
  while ($row = spip_fetch_array($result_breve)) {
    $chaine .= $row['id_forum'].",";
  }
	
  return "(".$chaine."0)";
}




///////////////////////////////////
// Rcupre les groupes d'un auteur 
///////////////////////////////////

function groupes_tableau($id_auteur) {
  $res = spip_query("SELECT sga.id_groupe, sg.statut ".
		    "FROM spip_groupes_auteurs AS sga, spip_groupes AS sg ".
		    "WHERE sga.id_auteur='$id_auteur' AND sg.statut!='5poubelle' AND sga.id_groupe=sg.id_groupe");
  while($row = spip_fetch_array($res))
    $groups[] = $row['id_groupe'];

  unset($res, $row);

  return $groups;
}




/////////////////////////////////////////////////////////
// Renvoie les groupes d'un auteur sous forme d'un texte
////////////////////////////////////////////////////////

function groupes_texte($id_auteur) {
  $g_t = groupes_tableau($id_auteur);

  if (count($g_t) != 0) 
    return ("(".implode(",", $g_t).")");
  else
    return ("(0)");
}



/////////////////////////////////////////////////////////////////////////////////
// Rcupre les groupes d'un auteur dans la bd ou sur la page (auteur_infos.php3)
/////////////////////////////////////////////////////////////////////////////////

function groupes_recup($groupes, $id_auteur) {

  if (count($groupes) == 0) {
    $groups = groupes_tableau($id_auteur);
  }
  else {
    $groups = $groupes;
  }
  
  return ($groups);

}



///////////////////////////////////////////////////////
// Insre les groupes d'un auteur dans la base
// On est obligatoirement dans le groupe Public (id : 1)
///////////////////////////////////////////////////////

function groupes_modification($groupes, $id_auteur) {

  spip_query("DELETE FROM spip_groupes_auteurs WHERE id_auteur='$id_auteur'");
  if (count($groupes) >= 1) {
    $query = "INSERT INTO spip_groupes_auteurs(id_groupe, id_auteur) VALUES ";
    foreach($groupes as $i) {
      $query .= "('$i', '$id_auteur') ,";
    }
    $query = substr($query, 0, strlen($query) - 2);
    spip_query($query) or die($query);
  }

  unset($i);
}



//////////////////////////////////////////////////////////////////
// Cre les checkboxes de slection de groupes (auteur_infos.php3)
//////////////////////////////////////////////////////////////////

function affiche_checkbox_groupes($groups, $new_auteur="non") {  //$new_auteur = "oui" OU "non"

  global $connect_id_auteur;

  //connect_id_auteur=1 par defaut : vision du super_admin

  if ($connect_id_auteur!=1) {
    $r = spip_query(" SELECT DISTINCT g.id_groupe, g.nom_groupe, g.statut FROM spip_groupes AS g, "
		    ." spip_groupes_auteurs AS ga WHERE"
		    ." g.id_groupe=ga.id_groupe AND ga.id_auteur='$connect_id_auteur' ORDER BY g.id_groupe");   
  }
  else {
    $r = spip_query(	 "SELECT id_groupe, nom_groupe, statut FROM spip_groupes" );
  }
 
  unset($i);
  
  echo "<br><b>Groupes associs :</b>";
  echo "<table width=100%>";
  while($rw = spip_fetch_array($r)) {
    if ($rw['statut'] != '5poubelle') {
      $i++;
      if (($i%3)==1)
	echo "<tr>";
      echo ("<td><input type='checkbox' name='groupes[]' value='".$rw['id_groupe']."'");
      if ( ($rw['id_groupe'] == 1) and $new_auteur=="oui") echo " CHECKED";  // check la box si nouvel auteur
      if (count($groups) != 0) {
	foreach($groups as $g) {
	  if ($g == $rw['id_groupe']) echo " CHECKED";
	}
      }
      echo (">".$rw['nom_groupe']."</td>");
      if (($i%3)==0) {
	echo "</tr>";
      }
    }
  }
  echo "</table>";

  // Effacement des variables utilises
  unset($rw, $r, $i);
}




////////////////////////////////////////////////////////////////////////
// Renvoie le nom des groupes de l'auteur $id_auteur sous la forme d'un texte
// si on est minirezo alors on voie tout
// sinon on voie tous ces groupes
//   et ceux que l'on a en commun avec les autres.
/////////////////////////////////////////////////////////////////////////

function groupes_auteur_affichage($id_auteur, $connect_id_auteur, $connect_statut) {

  $query = "SELECT DISTINCT spip_groupes.nom_groupe AS nom ".
     "FROM spip_groupes, spip_groupes_auteurs ".
     "WHERE spip_groupes_auteurs.id_auteur='$id_auteur' ". 
     "AND spip_groupes_auteurs.id_groupe=spip_groupes.id_groupe AND spip_groupes.statut!='5poubelle'";

  if ( ($connect_statut != "0minirezo" or ($connect_statut == "0minirezo" AND $connect_id_auteur!=1) ) AND ($id_auteur != $connect_id_auteur)) {
    $res = spip_query("SELECT id_groupe FROM spip_groupes_auteurs WHERE id_auteur='$connect_id_auteur'");
    $grp = "(";
    while ($row = spip_fetch_array($res))
      $grp .= $row['id_groupe'].",";
    $grp .= "0)";

    $query .= " AND spip_groupes_auteurs.id_groupe IN $grp";

    unset($grp);
  }

  $res = spip_query($query);

  while ($row = spip_fetch_array($res)) {
    $n_g[] = $row['nom'];
  }

  if (count($n_g) != 0) {
    sort($n_g);
    $nom_groupes = implode(",", $n_g);
  }
  else 
    $nom_groupes = " ";

  unset($row, $res, $query);

  return $nom_groupes;

}




/////////////////////////////////////////////////////////////////
// Construit le bout de requte pour voir les auteurs d'un groupe
// si on est minirezo, on voit tout
// sinon on est limit aux auteurs de son groupe.
/////////////////////////////////////////////////////////////////

function groupes_requete($connect_id_auteur, $connect_statut) {

  if ($connect_statut != '0minirezo') {
    $query2 = "SELECT id_groupe FROM spip_groupes_auteurs WHERE id_auteur='$connect_id_auteur'";
    $res = spip_query($query2);
    $row = spip_fetch_array($res);
    $grp = "(".$row['id_groupe'];
    while ($row = spip_fetch_array($res))
      $grp .= ", ".$row['id_groupe'];
    $grp .= ")";

    $query = "SELECT id_auteur FROM spip_groupes_auteurs WHERE id_groupe IN $grp";
    $res = spip_query($query);
    $row = spip_fetch_array($res);
    $aut = "(".$row['id_auteur'];
    while ($row = spip_fetch_array($res))
      $aut .= ", ".$row['id_auteur'];
    $aut .= ")";

    $requete = " AND id_auteur IN $aut";

    unset($query, $query2, $res, $row, $aut, $grp);
  }
  else {
    $requete = " ";
  }

  return $requete;
}


///////////////////////////////////////////////////////////////////
// Rcupre sous forme d'un tableau les rubriques du groupe $groupe
///////////////////////////////////////////////////////////////////

function rubriques_groupe($leparent, $groupe, $id_rub_sel = -1) {

  global $i;
  global $couleur_claire;
  static $rub;

  if ($leparent == 0) $rub = array();
  
  $i++;
  if($leparent == 0) {
    $query ="SELECT DISTINCT id_rubrique FROM spip_groupes_rubriques WHERE id_groupe='$groupe'";
    $result = spip_query($query);
    while ($row = spip_fetch_array($result))
      $rubrik .= $row['id_rubrique'].",";
    $rubrik = "(".substr($rubrik,0,strlen($rubrik) - 1).")";
    $query="SELECT DISTINCT * FROM spip_rubriques WHERE id_parent='$leparent' AND id_rubrique IN $rubrik ORDER BY titre";
  }
  else
    $query="SELECT DISTINCT * FROM spip_rubriques WHERE id_parent='$leparent' ORDER BY titre";
  
  $result=spip_query($query);

  while($row=spip_fetch_array($result)){
    $my_rubrique=$row['id_rubrique'];
    $titre=typo($row['titre']);
    $statut_rubrique = $row['statut'];

    $espace="";
    for ($count=1;$count<$i;$count++)
      $espace.="&nbsp;&nbsp;&nbsp; ";
    
    if ($i > 3) $c = "#666666";
    if ($i > 4) $fs = "italic";
    if ($i < 3) $fw = "bold";
    if ($i==1) {
      $espace= "";
      $bgc = "$couleur_claire";
    }
		
    if ($statut_rubrique!='publie') $titre = "($titre)";
		  
    $rub[] = Array ('titre' => $espace.addSlashes($titre), 'option' => $my_rubrique,
		    'bgc' => $bgc, 'c' => $c, 'fs' => $fs,'fw' => $fw, 'niveau' => $i);
		
    // Sert  ne pas voir les sous-rubriques
    // utile uniquement lors de la modification d'un rubrique
    if ($my_rubrique != $id_rub_sel) {
      rubriques_groupe($my_rubrique, $groupe);
    }
  }
  $i=$i-1;
  return $rub;
}




////////////////////////////////////////////////////////////////////
// Gnre le code javascript de modification de la liste de rubrique
// en fonction du groupe slectionn.
////////////////////////////////////////////////////////////////////

function menu_liste_rubrique($page, $id_rbq_selected = 0) {

  global $connect_statut;
  global $connect_id_auteur;
  global $couleur_foncee;

  $requete = "\n";

  $form = "document.form1";

  if ($page != 'breve' and $page != 'site')
    $nom_select = 'id_parent';
  else
    $nom_select = 'id_rubrique';

  if ($connect_statut == '0minirezo')
    if ($connect_id_auteur != 1) 
      $query = "SELECT * FROM spip_groupes WHERE statut!='5poubelle' AND id_groupe IN ".groupes_texte($connect_id_auteur);
    else
	$query = "SELECT * FROM spip_groupes WHERE statut!='5poubelle'";
  else {
     $query ="SELECT id_groupe FROM spip_groupes_auteurs WHERE id_auteur='$connect_id_auteur'";
     $result = spip_query($query);
     while ($row = spip_fetch_array($result))
       $grp .= $row['id_groupe'].",";
     $grp = "(".substr($grp,0,strlen($grp) - 1).")";

     $query = "SELECT * FROM spip_groupes WHERE id_groupe IN $grp AND statut!='5poubelle'";
   }

  $result = spip_query($query);

  $requete .= "if ($form.select_groupe.value == '0') {\n$form.$nom_select.options.length=0;\n"
     ."$form.$nom_select.options[0]=new Option('Slectionner un groupe...','0');\n"
     ."$form.$nom_select.options[0].style.backgroundColor='$couleur_foncee';\n}\n";


  while ($row = spip_fetch_array($result)) {
    $sous_requete = "";

    if ($id_rbq_selected == 0)
      $rubrique = rubriques_groupe(0, $row['id_groupe']);
    else 
      $rubrique = rubriques_groupe(0, $row['id_groupe'], $id_rbq_selected);
      
    $sous_requete .= "else if ($form.select_groupe.value == '".$row['id_groupe']."') {\n";
    $sous_requete .= "$form.$nom_select.options.length=0;\n";
    $i = 0; $j = 0;

    if (($i == 0) and ($page == 'rubrique')) {
	  $sous_requete .= "$form.$nom_select.options[$i]=new Option('Racine du groupe','0');\n";
      $sous_requete.= "$form.$nom_select.options[$i].style.backgroundColor='$couleur_foncee';\n";
      $i++;
    }

    if ($page != 'breve') {
      foreach($rubrique as $g) {
	$sous_requete .= "$form.$nom_select.options[$i]=new Option('".$g['titre']."','".$g['option']."');\n";
	if ($g['option'] == $id_rbq_selected) $sous_requete .= "$form.$nom_select.options[$i].selected=true;\n";
	if ($g['bgc'] != "") $sous_requete.= "$form.$nom_select.options[$i].style.backgroundColor='".$g['bgc']."';\n";
	if ($g['c']   != "") $sous_requete.= "$form.$nom_select.options[$i].style.color='".$g['c']."';\n";
	if ($g['fs']  != "") $sous_requete.= "$form.$nom_select.options[$i].style.fontStyle='".$g['fs']."';\n";
	if ($g['fw']  != "") $sous_requete.= "$form.$nom_select.options[$i].style.fontWeight='".$g['fw']."';\n";
	$i ++;
      }
    }
    else {
      foreach($rubrique as $g) {
	if ($g['niveau'] == 1) {
	  $sous_requete .= "$form.$nom_select.options[$j]=new Option('".$rubrique[$i]['titre']."','".$rubrique[$i]['option']."');\n";
	  if ($g['option'] == $id_rbq_selected) $sous_requete .= "$form.$nom_select.options[$j].selected=true;\n";
	  $j++;

	}
	$i++;
      }
    }
    
    // On affiche les groupes vides uniquement lors de la cration
    // de nouvelle rubrique. Sinon il faut afficher uniquement les
    // groupes avec une rubrique pour pouvoir publier une brve ou un
    // article.
    if ((count($rubrique) == 0)) {
      $sous_requete = "else if ($form.select_groupe.value == '".$row['id_groupe']."') {\n";
      $sous_requete .= "$form.$nom_select.options.length=0;\n";
      $sous_requete .= "$form.$nom_select.options[0]=new Option('Pas de rubrique dans ce groupe','0');\n";
      $sous_requete.= "$form.$nom_select.options[0].style.backgroundColor='$couleur_foncee';\n";
      $sous_requete .= "$form.$nom_select.options[0].selected = true;\n";
    }

    // Fin du code Javascript
    $sous_requete .= "}\n";

    if ((($page == 'article') and (count($rubrique) == 0)) | (($page == 'breve') and (count($rubrique) == 0)))
      $sous_requete = "";
    
    $requete .= $sous_requete;
  }

  return $requete;
}

?>